#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################

from AccessControl import ClassSecurityInfo

from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.WorkflowCore import WorkflowAction
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFDefault.File import File

from Acquisition import aq_base, aq_parent, aq_inner, aq_acquire 

from Products.CMFDocMgt import DocMgtFilePermissions

from DateTime.DateTime import DateTime
from Globals import InitializeClass

import mimetypes

from cStringIO import StringIO


import os, os.path, string, types, urllib, mimetypes, sys
import OFS


factory_type_information = ( { 'id'             : 'DocMgtFile'
                             , 'meta_type'      : 'DocMgtFile'
                             , 'description'    : """\
DocMgtFile can hold arbitrary binary data."""
                             , 'icon'           : 'file_icon.gif'
                             , 'product'        : 'CMFDocMgt'
                             , 'factory'        : 'addDocMgtFile'
                             , 'immediate_view' : 'docmgtfile_edit_form'
                             , 'global_allow' : 0
                             , 'allow_discussion' : 1
                             , 'actions'        :
                                ( { 'id'            : 'view'
                                  , 'name'          : 'View'
                                  , 'action'        : 'docmgtfile_view'
                                  , 'permissions'   : (
                                      CMFCorePermissions.View, )
                                  }
                                , { 'id'            : 'edit'
                                  , 'name'          : 'Edit'
                                  , 'action'        : 'docmgtfile_edit_form'
                                  , 'permissions'   : (
                                      DocMgtFilePermissions.ChangeFile, )
                                  }
                                )
                             }
                           ,
                           )

def addDocMgtFile( self
           , id=''
           , title=''
           , file=''
           , precondition=''
           ):
    self=self.this()
    if title=='':
        title=id
    bnNew = hasattr(self, id)
    
    fobj = DocMgtFile( id, title, file=file, precondition=precondition
               )
    
    portal_membership = self.portal_membership
    author = portal_membership.getAuthenticatedMember()
    
    fobj.manage_addProperty('author', author, 'string')
    # docstatus: 0=normal; 1=checkout; 2=approved;
    fobj.manage_addProperty('docstatus', '0', 'string')
    
    fobj.manage_addProperty('deadline', '2049/12/31', 'date')
    fobj.manage_addProperty('email', '', 'string')
    fobj.manage_addProperty('actionusr', '', 'string')
    fobj.manage_addProperty('actiondate', '1900/1/1', 'date')
    # Add the File instance to self
    #self.allowDiscussion = 1
    self._setObject(id, fobj)
    self._getOb(id).manage_upload(file)
    
    #obj = self.__of__()
    #newpath= self.getRevPath()
    #self.RevisionManager.add([newpath])
    

class DocMgtFile( File  ):
    meta_type='DocMgtFile'
    manage_options = File.manage_options

    security = ClassSecurityInfo()
    #global_allow = 0

    def __init__( self
                , id
                , title=''
                , file=''
                , precondition=''
                ):
                
        if title=='':
            title=id            
        File.__init__( self
                       , id=id
                       , title=title
                       , file=file
                       , precondition=precondition)
        
        
        

    security.declareProtected( DocMgtFilePermissions.ChangeFile, 'edit' )
    def edit( self, title=None, description=None, precondition='', file='', author=None, email=None, docstatus=None, deadline='2049/12/31', content_type='', **kwag ):
        """
            Edit File
        """
        self.author = author
        
        if email <> None:
            self.email = email
        elif kwag.has_key('email'):
            self.email = email
        if docstatus <> None:
            self.docstatus = docstatus
        elif kwag.has_key('docstatus'):
            self.docstatus = docstatus
        if deadline <> None:
            self.deadline = deadline
        elif kwag.has_key('deadline'):
            self.docstatus = deadline
        
        if title <> None:
            self.setTitle(title)
        elif kwag.has_key('title'):
            self.setTitle = title
        if description <> None:
            self.setDescription(description)
        elif kwag.has_key('description'):
            self.setDescription = description
        
        if content_type <> '':
            self.content_type = content_type
        elif kwag.has_key('content_type'):
            self.content_type = content_type
        #else:
        #    if file<>'':
        #        tmp = file.headers['Content-Type']
        #    if tmp == '':
        #        tmp = self.cmfdocmgt_tool.DefaultContentType #'application/octet-stream'
        #    self.content_type = tmp
            
        oldsize= self.get_size()
        File.edit( self, precondition=precondition, file=file)
        if file <> '':
        
            #revmgr = self.RevisionManager
            #newpath= self.getRevPath()
            if not self.REQUEST.get('MappingRM', 0):
                
                if oldsize == 0:
                    self.addRev()
                    
                else:
                    #revmgr.status([newpath])
                    log = 'New file content uploaded'
                    self.updateRev(log)
        

    security.declareProtected( DocMgtFilePermissions.ChangeFile, 'updateRev' )
    def updateRev( self, log):
        if self.get_size():
            revmgr = self.getRM()
            newpath= self.getRevPath()
            revmgr.status([newpath])
        
            revmgr.commit(log, [newpath])

    security.declarePrivate('addRev')
    def addRev( self ):
        if self.get_size():
            revmgr = self.getRM()
            newpath= self.getRevPath()
            revmgr.add([newpath])
    
    security.declarePrivate('removeRev')
    def removeRev( self ):
        revmgr = self.getRM()
        newpath= self.getRevPath()
        revmgr.remove([newpath])

    def getRM(self):
        paths = self.getPhysicalPath()
        lp = len(paths)
        found = None
        for i in range(lp):
            temp = self.restrictedTraverse(paths[:lp - i - 1])
            if hasattr(aq_base(temp),'RevisionManager'):
                found = temp
        if found <> None:
            return found['RevisionManager'] #self.restrictedTraverse(found['RevisionManager'].getPhysicalPath())

    def getRMParent(self):
        paths = self.getPhysicalPath()
        lp = len(paths)
        found = None
        for i in range(lp):
            temp = self.restrictedTraverse(paths[:lp - i - 1])
            if hasattr(aq_base(temp),'RevisionManager'):
                found = temp
        if found <> None:
            return found #self.restrictedTraverse(found.getPhysicalPath())

        
    def getRevPath(self):
        paths = self.getPhysicalPath()
        rmp = self.getRMParent()
        if rmp:
            return '/'.join(paths[len(rmp.getPhysicalPath()):])

    #def getRevPath(self):
    #    parent= self.aq_parent
    #    while not parent.isPrincipiaFolderish:
    #        parent= parent.aq_parent
    #    
    #    #test = parent.absolute_url()
    #    portal_url = parent.portal_url
    #    #portal = self.aq_inner.aq_parent
    #    
    #    paths = string.split(portal_url.getRelativeUrl(parent) + '/' +  self.getId(), '/')
    #            
    #    #newpath= string.join(paths[len(paths):], '/')
    #    
    #    #pos = len(paths)-1
    #    
    #    #newpath = string.join(paths, '/') #string.join(paths[index:], '/')
    #    
    #    #newpath = string.join(paths[index:], '/')
    #    #temp.getId()
    #    
    #    
    #    base = portal_url.getPortalObject()
    #    #if (not hasattr(temp.aq_explicit, 'RevisionManager')) and temp <> base:
    #    #    temp = temp.aq_parent
    #    #tes=0
    #    #test = '['
    #    while not getattr(aq_base(parent), 'RevisionManager', None) : #and temp <> base:
    #        #pos = pos - 1
    #        #test = test + ', ' + parent.absolute_url()
    #        #tes=tes + 1
    #        parent = parent.aq_parent
    #    #test = test + ']'
    #    
    #    p = string.split(portal_url.getRelativeUrl(parent), '/')
    #    pos = 0
    #    for i in range(len(p)):
    #        pos =pos + 1
    #        
    #    #newpath =  str(len(p)) + ' ' + str(pos)  + '###' + parent.absolute_url() +'###' + string.join(paths, '/') + '###' + str(pos)  + '###' +str(tes) 
    #    newpath = string.join(paths[pos:], '/')                   
    #    return newpath

#def getRevPath(self):
#        temp = self
#        portal_url = self.portal_url
#        
#        temp = portal_url.restrictedTraverse(portal_url.getRelativeUrl(self))
#        paths= string.split(portal_url.getRelativeUrl(temp), '/')
#        
#        revmgr = getattr(self, 'RevisionManager', None)
#        if revmgr ==None:
#            return '1' # None
#            
#        revmgr = portal_url.restrictedTraverse(revmgr.aq_explicit.absolute_url('relative'))
#        
#        rootpaths = string.split(portal_url.getRelativeUrl(revmgr.aq_parent), '/')
#        
#        for i in range(len(rootpaths)):
#            if rootpaths[i]<>paths[i]:
#                #return None	# error occurs here
#                return '2' + string.join(paths, '/')	+ string.join(paths, '/') 
#                
#        newpath= string.join(paths[len(rootpaths):], '/')
#        
#        #index = len(paths)
#        ##newpath = string.join(paths[index:], '/')
#        ##temp.getId()
#        #
#        #
#        #base = portal_url.getPortalObject()
#        ##if (not hasattr(temp.aq_explicit, 'RevisionManager')) and temp <> base:
#        ##    temp = temp.aq_parent
#        #while (not hasattr(temp.aq_explicit, 'RevisionManager')) : #and temp <> base:
#        #    index = index -1
#        #    #newpath = temp.getId() + '/' + newpath
#        #    newpath = string.join(paths[index:], '/')
#        #    temp = temp.aq_parent
#        return '3' + newpath

    def getPropertyValue( self, name, properties='' ):
        if properties:
            pa = properties.split('\n')
            for i in range(len(pa)):
                try:
                    tmp= pa[i].split('=')
                    key = tmp[0]
                    value=tmp[1]
                    if key[:len(name)+1]==name + ':':
                        return value
                except:
                    continue
            
        
    
    security.declarePrivate('manage_afterAdd')
    def manage_afterAdd(self, item, container):
        File.manage_afterAdd(self,item, container)
        
        self.addRev()
        #if self.get_size():
            #newpath= self.getRevPath()
            #self.RevisionManager.add([newpath])
            
            
            #container.setTitle(newpath)
            #self.RevisionManager.commit('system commit', [newpath])

    security.declarePrivate('manage_beforeDelete')
    def manage_beforeDelete(self, item, container):
        File.manage_beforeDelete(self,item, container)
        
        self.removeRev()
        #if self.get_size():
        #    newpath= self.getRevPath()
        #    self.RevisionManager.remove([newpath])
            
            
        #self.RevisionManager.commit('system commit', [newpath])

    security.declarePrivate('manage_afterClone')
    def manage_afterClone(self, item):
        
        File.manage_afterClone(self,item)
        self.addRev()
        #if self.get_size():
        #    newpath= self.getRevPath()
        #    self.RevisionManager.add([newpath])
        #self.RevisionManager.commit('system commit', [oldpath, newpath])

    security.declareProtected( DocMgtFilePermissions.ChangeFile, 'checkOut' )
    def checkOut(self, REQUEST, RESPONSE):
        self.manage_changeProperties({'docstatus':'1',
									'actionusr': str(REQUEST.AUTHENTICATED_USER),
									'actiondate': DateTime()
									})

    security.declareProtected( DocMgtFilePermissions.ChangeFile, 'checkIn' )
    def checkIn(self, file, log, precondition='', REQUEST=None, RESPONSE=None):
        author = self.portal_membership.getAuthenticatedMember().getUserName()
        self.manage_changeProperties({'docstatus':'0',
									'actionusr': author
									})
        #logmsg = '%s|\~%s|\~%s'%(str(REQUEST.AUTHENTICATED_USER ),email, log)
        
        File.edit( self, precondition=precondition, file=file)
        sgPath= self.getRevPath()
        self.updateRev(log)
        
        #revmgr = self.RevisionManager
        #revmgr.status([sgPath])
        #revmgr.commit(log, [sgPath])
        
    security.declareProtected( DocMgtFilePermissions.ChangeFile, 'approve' )
    def approve(self, REQUEST, RESPONSE):
        self.manage_changeProperties({'docstatus':'2',
									'actionusr': str(REQUEST.AUTHENTICATED_USER),
									'actiondate': DateTime()
									})
        #RESPONSE.redirect(self.aq_parent.absolute_url()+'/view')

    security.declareProtected( DocMgtFilePermissions.ChangeFile, 'undoaction' )
    def undoaction(self, REQUEST, RESPONSE):
        self.manage_changeProperties({'docstatus':'0',
									'actionusr': ''
									})
        #RESPONSE.redirect(self.aq_parent.absolute_url()+'/view')
    
    def retrieve(self, filename="", tag="", recursive=1, prune_empty=0,pipe=0,
               new_dirs=0, reset_sticky=0):
        """
        perform a CVS update
        """
        
        
        cvs = self.RevisionManager._get_wrapper()
        
        cvs._prepare()
        cmdopt = ""
        if not recursive:
            cmdopt += "-l"
        if prune_empty:
            cmdopt += " -P"
        if pipe:
            cmdopt += " -p"
        if new_dirs:
            cmdopt += " -d"
        if reset_sticky:
            cmdopt += " -A"
        if tag:
            cmdopt = "-r %s %s" % (tag, cmdopt)
        result_val, result_out, result_err = \
                    cvs._exec_cmd("update", "", cmdopt, filename)
        cvs._clean_up()

        # updatedict = cvs.parse_listout(result_out)
        # updatedict.update(cvs.parse_update_removed(result_err))
        return result_out        
    

    security.declareProtected( CMFCorePermissions.View, 'downloadRev' )
    def downloadRev(self, reqrev='', REQUEST=None, RESPONSE=None):
        sg = ''
        sgPath= self.getRevPath()
        lastrev = self.getLastRevNo()
        if reqrev =='':
            reqrev = lastrev
        else:
            sg = '.' + reqrev
        sg = sg.replace('.', '_')
        contentExt = self.getContentExtension()
        revmgr = self.RevisionManager
        
        #revmgr.update([sgPath], tag=reqrev, reset_sticky=1)
        
        paths=[sgPath]
        settings = revmgr._settings
        #if settings['save_properties']:
        #    paths = revmgr.addPropertyPaths(paths)
        escaped_paths = revmgr._escape_spaces(paths)
        
        
        #abs_filename = revmgr.getAbsoluteFilePath(sgPath)
        data = self.retrieve(filename=" ".join(escaped_paths), tag=reqrev, pipe=1)
        #data = self.retrieve(filename=[sgPath], tag=reqrev, pipe=1)

        #abs_filename = revmgr.getAbsoluteFilePath(sgPath)
        #data = open(abs_filename, "rb").read()
        
        #revmgr.update([sgPath], reset_sticky=1)
        
        #data = File.download(self, REQUEST, RESPONSE)
        RESPONSE.setHeader('Content-Type', 'application/download')
        RESPONSE.setHeader('Content-Length', len(data))
        RESPONSE.setHeader('Content-Disposition', 'attachment; filename=%s' % (self.getId()+ sg + contentExt))

        
        return  data


        
    security.declarePrivate('getLastRevNo')
    def getLastRevNo(self):
        sgSrcRevPath = self.getRevPath()
        paths = [sgSrcRevPath]
        revmgr = self.RevisionManager
        #log = revmgr.log(paths)
        cvs = revmgr._get_wrapper()
        revmgr.clearLazyTraverse()
        log = cvs.log(" ".join(paths))
        
        filenames = log.keys()
        lastrev = ''
        lastrevdate = ''
        for f in paths:
        	log_info = log[f]
        	for rev in log_info['revisions']:
        		moddate = rev['date'] #.strftime('%Y-%m-%d %I:%M:%S %p')
       			if lastrevdate < moddate :
       				lastrevdate = moddate
       				lastrev = rev['revision']
        return lastrev

    security.declarePrivate('getContentExtension')
    def getContentExtension(self):
        contenttype = self.content_type
        ext = mimetypes.guess_extension(contenttype)
        
#        ret = ''
#        contenttype = self.content_type
#        if contenttype in ('application/msword', 'text/richtext'):
#        	ret = 'doc'
#        elif contenttype=='application/vnd.ms-excel':
#        	ret = 'xls'
#        elif contenttype=='application/pdf':
#        	ret = 'pdf'
#        elif contenttype=='application/vnd.ms-powerpoint':
#        	ret = 'ppt'
#        elif contenttype=='application/x-zip-compressed':
#        	ret = 'zip'
#        elif contenttype=='audio/wav':
#        	ret = 'wav'
#        elif contenttype=='application/vnd.rn-realmedia':
#        	ret = 'rm'
#        elif contenttype=='video/x-ms-wmv':
#        	ret = 'wmv'
#        elif contenttype=='video/mpeg':
#        	ret = 'mpeg'
#        elif contenttype=='text/html':
#        	ret = 'html'
#        elif contenttype=='text/plain':
#        	ret = 'txt'
#        elif contenttype=='image/x-png':
#        	ret = 'png'
#        elif contenttype=='image/gif':
#        	ret = 'gif'
#        elif contenttype=='image/pjpeg':
#        	ret = 'jpg'
#        elif contenttype=='audio/x-ms-wma':
#        	ret = 'wma'
#        elif contenttype=='audio/x-pn-realaudio':
#        	ret = 'rm'
#        elif contenttype=='application/x-shockwave-flash':
#        	ret = 'swf'
#        else:
#        	if contenttype.find('text') > -1:
#        		ret = 'txt'
#        	elif contenttype=='application/octet-stream':
#        		ret = self.cmfdocmgt_tool.DefaultFileExtension #'dat'	#default file type
#        
        return ext


    #############################################################################
    ##                             Syndication                                 ##
    #############################################################################

    security.declareProtected( CMFCorePermissions.View, 'queryCatalog' )
    def queryCatalog( self, REQUEST=None, **kw ):
        query = {'path': self.absolute_url('relative'),
                'meta_type' :['DocMgtFile'],
                }

        kw.update(query )
        return apply( self.portal_catalog.searchResults, ( REQUEST, ), kw )


    security.declarePublic('synContentValues')
    def synContentValues(self):
        """ play nice with portal_syndication_tool"""
        return self.queryCatalog()
        
    #############################################################################
    ##                             FTP                                         ##
    #############################################################################

#    security.declareProtected(CMFCorePermissions.ModifyPortalContent, 'PUT')
#    def PUT(self, REQUEST, RESPONSE):
#        """ Handle HTTP (and presumably FTP?) PUT requests """
#        #File.PUT( self, REQUEST, RESPONSE )
#        parent =self.aq_parent
#        File.PUT( self, REQUEST, RESPONSE )
#        
#        size= self.get_size()
#        if size >0:
#        
#            #revmgr.status([newpath])
#            log = 'FTP uploaded content'
#            
#            #self.updateRev(log)
#            #revmgr.commit(log, [newpath])        
#            me = parent[self.id]
#            me.getRevPath()
#            me.getRM()
#            me.getRMParent()
#            #paths = self.getPhysicalPath()
#            #lp = len(paths)
#            #found = None
#            #for i in range(lp):
#            #    temp = self.restrictedTraverse(paths[:lp - i - 1])
#            #    if hasattr(aq_base(temp),'RevisionManager'):
#            #        found = temp
#            #if found <> None:
#            return rp+ pp #found['RevisionManager'] #self.restrictedTraverse(found['RevisionManager'].getPhysicalPath())
#        #self.reindexObject()    
InitializeClass(DocMgtFile)



